import java.util.*;

public class pp {
	
	static ArrayList<Long> allPrimes;
	
	private static void createPrimes() {
		allPrimes = new ArrayList<Long>();
		
		boolean[] temp = new boolean[46350];
		int top = 220;
		
		temp[0] = true;
		temp[1] = true;
		
		for (int i = 2; i < top; i ++) {
			if (temp[i]) {
				continue;
			}
			long j = i * 2;
			do {
				temp[(int)j] = true;
				j += i;
			}
			while (j < temp.length);
		}
		
		for (int i = 0; i < temp.length; i++) {
			if (!temp[i]) {
				allPrimes.add((long)i);
			}
		}			
	}
	
	static boolean lzeRozlozit(long cislo, long[] myPrimes) {
		for (long prime : myPrimes)
		{
			while (cislo % prime == 0) {
				cislo /= prime;
			}
		}
		
		if (cislo == 1) return true;
		
		return false;
	}
	
	static void cancelNumbers(long fromNumber, long primeStart, TreeSet<Long> set, long[] myPrimes, long a, long b) {
		LinkedList<Long> froms = new LinkedList<Long>();
		LinkedList<Long> starts = new LinkedList<Long>();
		
		froms.addLast(fromNumber);
		starts.addLast(primeStart);
		
		while (froms.size() > 0) {
			fromNumber = froms.remove();
			primeStart = starts.remove();
			
		   for (int i = (int)primeStart; i < myPrimes.length; i++)
			{				
				long number = fromNumber * myPrimes[i];
				while (number <= b)  {
					if (number >= a) set.add(number);
					
					froms.addLast(number);
					starts.addLast((long)i + 1L);
					
					number *= myPrimes[i];
				}
			}
		}
	}
	
	public static void main(String[] args)
	{
		Scanner sc = new Scanner(System.in);
		String line;
		
		//createPrimes();

				
		while (sc.hasNextLine())
		{
			long primeCount = sc.nextInt();
			
			if (primeCount == 0) return;
			
			sc.nextLine();
			
			long[] myPrimes = new long[(int)primeCount];
			
			for (int i = 0; i < primeCount; i++)
			{
				myPrimes[i] = sc.nextInt();
			}
			
			sc.nextLine();
			long a= sc.nextInt();
			long b= sc.nextInt();
			sc.nextLine();
			
			TreeSet<Long> set = new TreeSet<Long>();
				/*
			long nejm = 0;
			for (long cislo = a; cislo <= b; cislo++) {
				if (!lzeRozlozit(cislo, myPrimes)) {
					continue;
				}
				nejm = cislo;
				break;
			}*/

			//set.add(nejm);
			/*
			if (nejm == 0) {
				System.out.println("none");
				continue;
			}*/
			
			if (a <= 1) set.add(1L);
			
			cancelNumbers(1L,0L,  set, myPrimes,a, b);
			

			/*
			for (long i = a; i <= b; i++)
			{
				boolean ok = true;
				for (long j = 0; j < allPrimes.size() && allPrimes.get(j) <= b; j++) {
					
					if (i % allPrimes.get(j) == 0) {
						if (Arrays.binarySearch(myPrimes, allPrimes.get(j)) < 0) {
							ok = false;
							break;
						}
					}
					
				}
				if (ok) {
						res.add(i);
					}
			}*/
			/*
			ArrayList<Long> res = new ArrayList<Long>();
			for (long i = nejm; i <= b; i++) {
				if (!set.contains(i)) {
					res.add(i);
				}
			}*/
			
			Iterator<Long> it = set.iterator();
			/*for (long i = 0; i < set.size(); i++) {
				System.out.print(it.next());
				if (i != set.size() - 1) {
					System.out.print(",");
				}
			}*/
			
			while (it.hasNext()) {
				System.out.print(it.next());
				if (it.hasNext()) {
					System.out.print(",");
				}
			}
			
			if (set.size() == 0) System.out.print("none");
			System.out.println();
						
			
		}

		
	}
}